Program MP3_Rename_It;   { 20.10.1999-2001 by RalphRoth@gmx.de }
{$I comp.pas}

{*****************************************************************************}
{*                                                                           *}
{* MP3 Renamer - using WinAMP play lists. Written by Ralph Roth              *}
{*                                                                           *}
{* Usage:                                                                    *}
{*                                                                           *}
{* Load a directory with MP3 files into WinAMP and save the playlist to      *}
{* a file. Then run this program with the playlist filename (8.3 convention) *}
{* as an argument. Take a look at the created renit.bat batch file and       *}
{* execute it. Yar done :)                                                   *}
{*                                                                           *}
{* Requires: Long file name support (e.g. Win32, OS/2, Linux etc.), 286++    *}
{*                                                                           *}
{* 20.10.99 - initial creation                                               *}
{* 04.12.99 - exec added                                                     *}
{* 17.08.00 - win32 port via fpc 1.00, .m3u default extension, works now     *}
{*            under NT 4.0 with long file names                              *}
{* 09.12.00 - Added the options -f, -?, -u, -s                               *}
{*                                                                           *}
{*                                                                           *}
{*                                                                           *}
{*****************************************************************************}

{
$Header: C:/TP/SRC/RCS/mp3renit.pas 1.4 2001/02/23 17:25:20 rar Exp $

$Log: mp3renit.pas $
Revision 1.4  2001/02/23 17:25:20  rar
1.80 with option -d (rename dir)

Revision 1.2  2000/12/23 20:28:07  ralph_zimmern
Version 1.61 with RCS 5.7.4 revision system

Revision 1.1  2000/12/23 20:25:54  ralph_zimmern
Initial revision

}

uses dos, r_utils;

Const
     bForce     : Boolean = FALSE;
     bUnderScore: Boolean = FALSE;
     bSwap      : Boolean = FALSE;
     bVarious   : Boolean = TRUE;
     bRenDir    : Boolean = FALSE;

Var szParam, szTmp  : String;
    szExtInfo: String;
    szMP3File: String;
    szCMD    : String;
    hIn, hOut: Text;
    lFiles   : LongInt;
    lConvert : LongInt;


{ ----------------------------------------------------------------------- }

Procedure Abort(szWhy: String);

Begin { Abort }
  writeln(GuruHeadLine('MP3RenIt - Fatal Error'));
  writeln;
  writeln(szWhy);
  writeln;
  writeln('Internal version $Id: mp3renit.pas 1.4 2001/02/23 17:25:20 rar Exp $');

  halt(1);
End; { Abort }

{ ----------------------------------------------------------------------- }

Procedure MP3Convert;

Var t     : Byte;
    szExt : String;
    bConvert : Boolean;

Begin { MP3Convert }

   readln(hIn, szMP3File);
   If (Pos('.MP',Upper(szMP3File))<1) Then exit;

   t := Pos(',', szExtInfo);
   szExtInfo := copy(szExtInfo, t+1, 255);

   { this is quick and dirty! }
   szExt := copy(szMP3File, Length(szMP3File)-3, 4);

   { skip spaces etc. }
   while(szExtInfo[1] In [' ','-','']) Do
     delete(szExtInfo, 1, 1);

   t := Pos(' - ', szExtInfo);

   If bSwap And (t>1) Then
     Begin
        szExtInfo := Copy(szExtInfo, t+3, 255)+' - '+ Copy(szExtInfo, 1, t);
     End;

   { szExt -> .mp3 }

   szExtInfo := szExtInfo + szExt;

   t := 1;
   while (t<=Length(szExtInfo)) Do
   Begin
      If szExtInfo[t] In ['/','&'] Then
         szExtInfo[t] := '_';

      If bUnderScore And (szExtInfo[t] = ' ') Then
         szExtInfo[t] := '_';

      If szExtInfo[t] In ['', #39, #44, #92, '"', #47, #$3f,'*', #0..#31]
        Then
         delete(szExtInfo, t, 1)
      Else
         inc(t);
   End;

   bConvert := (Length(szExtInfo) > Length(szMP3File)) Or bForce;

   if bVarious then
   begin
     If Pos('Various Artists - ', szExtInfo) = 1 Then
      Begin
        bConvert := TRUE; { force! }
        Delete(szExtInfo, 1, 18);
      End;
     If Pos('Various - ', szExtInfo) = 1 Then
      Begin
        bConvert := TRUE; { force! }
        Delete(szExtInfo, 1, 10);
      End;
   end; { if various }

   If bConvert Then
     Begin
        writeln(hOut, 'ren "'+szMP3File+'" "'+szExtInfo+'"');
        inc(lConvert);
     End;

End; { MP3Convert }

{ ----------------------------------------------------------------------- }


Procedure RenameDir(szDir: String);

var szHome : String;
        sr : SearchRec;
         t : Byte;
     szNew : String;

begin
     getdir(0, szHome);
     chdir(szDir);

     findfirst('*.*', Directory, sr);
     while (DosError = 0) do
     begin
        if (sr.attr AND Directory = Directory) AND (sr.name[1]<>'.') then
        begin
                szNew := sr.name;
                for t := 1 to length(szNew) do
                    if szNew[t] in [#0..' ', '/', '', '_' , #255] then
                        if bUnderScore then szNew[t] := '_'
                                       else szNew[t] := #255;

                write(sr.name, ' -> ', szNew, '  Res=');
                if (sr.name = szNew) then
                        writeln(' - SKIPPED (unchanged)')
                else
                begin
                        ExecCommand('move "'+sr.name+'" "'+szNew+'"');
                        writeln(ioresult,' (io)/',doserror,' (dos)');
                end;
        end;
        findnext(sr);
     end;

     chdir(szHome);

end;

{ ----------------------------------------------------------------------- }

Procedure usage;

Begin { usage, 09122000, rar }

      writeln('Usage:    mp3renit [-/options] m3u-playlist[.m3u] [-/options]');
      writeln;
      writeln('There are currently two different MP3Renit modi:');
      writeln('- directory renaming (-d), additional options:  -u');
      writeln('- renameing using M3U play list, additional options:   -f, -s, -u, -v');
      writeln('- renameing using the MP3 ID3v1 tag  (* future *)');
      writeln;
      writeln(GuruheadLine('Options'));
      writeln;
      writeln('-? /h     This short help');
      writeln('-f        Force the renaming. (Default: Smart renaming)');
      writeln('-d [dir]  Renames the subdirectory in [dir] | current folder (#32->#255 or -u)');
      writeln('-s        Swap artist and song name (Artist - Song  gets  Song - Artist)');
      writeln('-u        Replace spaces with underscores. E.g. "A_Artist_-_His_Song.mp3"');
      writeln('-v        Do not remove leading "Various [Artists] -".  Default = ON');

      writeln;
      writeln(GuruHeadLine('http://www.mp3.com/rose_swe'));
      writeln;
      halt(1);

End; { usage, 09122000, rar }

{ ----------------------------------------------------------------------- }

Var t : Byte;

Begin { MP3_Rename_It }

   Writeln; { cos nt sux }
   Writeln(GuruHeadLine('MP3RenIt 1.70'
          {$IFDEF WIN32} +'/Win32' {$ENDIF}          { fpc, win32 port :) }
           +' - (c) 1999-2001 by ROSE SWE, RalphRoth@gmx.de'));
   Writeln;

   lFiles  := 0;
   lConvert := 0;

   If ParamCount = 0 Then
      usage;

    For t := 1 To ParamCount Do
      Begin
         szTmp := ParamStr(t);
         If szTmp[1] In ['-', '/'] Then
            Case Upcase((szTmp[2])) Of
              'H', '?' : usage;
              'U'      : bUnderScore := TRUE;
              'F'      : bForce := TRUE;
              'S'      : bSwap := TRUE;
              'V'      : bVarious := FALSE;
              'D'      : bRenDir := TRUE;
              Else Abort('Known option: '+szTmp);
            End
         Else
             szParam := szTmp;
      End;

   if bRenDir then
   begin
        if not FindDir(szParam) then
        begin
             writeln('Directory "'+szParam+'" does not exist using current directory');
             getdir(0, szParam);
        end;
        RenameDir(szParam);
        halt(0);
   end;

   If Not exists(szParam) And (Pos('.', szParam) = 0)
     Then
        szParam := szParam + '.m3u';

   assign(hIn, szParam);
   If ioresult <> 0 Then Abort('File access error: '+szParam);
   reset(hIn);
   If ioresult <> 0 Then Abort('File open error: '+szParam);

   assign(hOut, 'RenIt.Bat');
   If ioresult <> 0 Then Abort('File access error: renit.bat');
   rewrite(hOut);
   If ioresult <> 0 Then Abort('File create error: renit.bat');
   writeln(hOut, '@Echo Off');

   readln(hIn);  { skip first entry }

   Repeat
         inc(lFiles);
         readln(hIn, szExtInfo);
         If (Pos('#EXTINF:',szExtInfo)=1)
           Then
             MP3Convert;

   Until eof(hIn) Or (ioresult<>0);

   close(hIn);
   close(hOut);

   writeln(lFiles,' MP3 entries read, ',lConvert,' entries convertable!');

   szCMD := GetEnv('COMSPEC');
   SwapVectors;
   exec(szCMD, '/c renit.bat');
   exec(szCMD, '/c del renit.bat > nul');
   SwapVectors;
   writeln(GuruHeadLine('Good-Bye!'));

End. { MP3_Rename_It }
